use std::fs::File;
use std::cmp;
use std::io::{self, prelude::*, BufReader};
use std::collections::HashMap;

fn do_cycle(mut wall_of_text: Vec<String>) -> Vec<String>{
    for _i in 0..4 {
        wall_of_text = move_to_top(wall_of_text);
        wall_of_text = rotate_left(wall_of_text);
    }
    wall_of_text
}

fn move_to_top(mut wall_of_text: Vec<String>) -> Vec<String>{
    let length = wall_of_text.len();
    for line in 1..length{
        for column in 0..wall_of_text[line].len(){
            if wall_of_text[line].get(column..column+1).unwrap() == "O"{
                wall_of_text[line].replace_range(column..column+1, ".");
                for i in (0..line).rev(){
                    if wall_of_text[i].get(column..column+1).unwrap() == "#" || wall_of_text[i].get(column..column+1).unwrap() == "O"{
                        wall_of_text[i+1].replace_range(column..column+1, "O");
                        break;
                    }
                    else if i == 0  {
                        wall_of_text[i].replace_range(column..column+1, "O");
                    }
                }
            }
        }
    }
    wall_of_text
}

fn rotate_left(wall_of_text: Vec<String>) -> Vec<String> {
    let rotate_text: Vec<String> = (0..wall_of_text[0].len()).map(|col| {
        (0..wall_of_text.len()).rev()
        .map(|row| wall_of_text[row].get(col..col+1).unwrap())
        .collect()
    }).collect();
    rotate_text

}

fn process_text(mut wall_of_text: Vec<String>) -> u32 {
    let mut answer = 0;
    let length = wall_of_text.len();
    let mut answers_vec = vec![];
    let mut cycle_found = false;
    for i in 0..1000000000 {
        let original = wall_of_text.clone();
        wall_of_text = do_cycle(wall_of_text);
        if original == wall_of_text {
            break;
        }
        let mut answer = 0;

        for line in 0..length{
            for column in 0..wall_of_text[line].len(){
                if wall_of_text[line].get(column..column+1).unwrap() == "O"{
                    answer += length-line;
                }
            }
        }

        // Some sketchy "look for a pattern and try to calculate the end result when one is found" type shit
        answers_vec.push(answer);
        for i in 0..answers_vec.len()
        {
            for j in i+10..answers_vec.len(){
                if answers_vec[j] == answers_vec[i] && answers_vec.len()>j+j-i
                {
                    cycle_found = true;
                    for k in 0..j-i{
                        if answers_vec[j+k] != answers_vec[i+k]{
                            cycle_found = false;
                            break;
                        }
                    }
                    if cycle_found {
                        let temp_mod = (1000000000-1 - i) % (j - i);
                        return answers_vec[i+temp_mod].try_into().unwrap();
                    }
                }
            }
        }
    }

    return answer.try_into().unwrap();
}

fn main() -> io::Result<()>  {
    let file = File::open("../input.txt")?;
    let reader = BufReader::new(file);
    let answer = process_text(
        reader.lines().collect::<io::Result<Vec<String>>>().expect("failed")
    );
    println!("{}", answer);

    Ok(())
}
