use std::fs::File;
use std::io::{self, prelude::*, BufReader};
use std::collections::HashMap;

fn get_hash(line:  &str) -> u32 {
    let mut ret = 0;
    for s in line.chars(){
        let ascii = s as u32;
        ret += ascii;
        ret = 17*ret;
        ret = ret%256;
    }
    // println!("{} {:?}", ret, line);
    return ret;
}

fn process_text(parts: Vec<&str>) -> u32 {
    let mut array_of_hash: HashMap<u32, Vec<(&str, u32)>> = HashMap::new();
    let mut ret = 0;
    for part in parts {
        //look for symbol
        for i in 0..part.len(){
            if part.get(i..i+1).unwrap() == "-" || part.get(i..i+1).unwrap() == "="
            {
                let idx = get_hash(part.get(0..i).unwrap());
                if part.get(i..i+1).unwrap() == "-"{
                    let get_idx = array_of_hash.get(&idx);
                    if get_idx.is_some() {
                        array_of_hash.get_mut(&idx).map(|val| {
                            for j in 0..val.len() {
                                // println!("{j:?}");
                                if val[j].0 == part.get(0..i).unwrap(){
                                    // println!("Trying to remove {} {}", idx, val[j].0);
                                    val.remove(j);
                                    break;
                                }
                            }
                            // val.remove(part.get(0..i).unwrap())
                        });
                        // array_of_hash[&idx].remove(part.get(0..i).unwrap());
                    }
                }
                else{
                    let get_idx = array_of_hash.get(&idx);
                    if get_idx.is_some() {
                        array_of_hash.get_mut(&idx).map(|val| {
                            let mut found = false;
                            for j in 0..val.len() {
                                // println!("{j:?}");
                                if val[j].0 == part.get(0..i).unwrap(){
                                    val[j].1 = part.chars().nth(i+1).unwrap() as u32 - '0' as u32;
                                    found = true;
                                    break;
                                }
                            }
                            if !found {
                                val.push((part.get(0..i).unwrap(), part.chars().nth(i+1).unwrap() as u32 - '0' as u32));
                            }});
                        // array_of_hash[&idx].remove(part.get(0..i).unwrap());
                    }
                    else{
                        let mut temp_hash = vec![];
                        temp_hash.push((part.get(0..i).unwrap(), part.chars().nth(i+1).unwrap() as u32 - '0' as u32));
                        array_of_hash.insert(idx, temp_hash);
                    }
                    // array_of_hash.entry(idx).or_insert(.entry(part.get(0..i).unwrap()).or_insert(part.chars().nth(i+1).unwrap() as u32 - '0' as u32));
                }
                break;
                
            }
            // println!("HASH, {array_of_hash:?}");
        }

        // ret += get_hash(part);
    }
    for (idx, inner_hash) in &array_of_hash{
        let mut slot = 1;
        for (key, focal_length) in inner_hash{
            let sum = (idx+1)*slot*focal_length;
            ret += sum;
            slot += 1;
            // println!("HASH, {sum:?}");
        }
        
    }
    // println!("HASH, {array_of_hash:?}");
    return ret;
}

fn main() -> io::Result<()>  {
    let file = File::open("../input.txt")?;
    let reader = BufReader::new(file);
    let line = reader.lines().collect::<io::Result<Vec<String>>>().expect("failed");
    let parts = line[0].split(&[',']).collect::<Vec<&str>>();
    let answer = process_text(
        parts
    );
    println!("{}", answer);
    

    Ok(())
}
