use std::fs::File;
use std::io::{self, prelude::*, BufReader};
use std::collections::HashMap;
use regex::Regex;

enum ModuleType {
    FlipFlop,
    Conjunction,
}

struct Module {
    kind: ModuleType,
    states: Vec<bool>,
    outputs: Vec<String>,
}


fn process_text(wall_of_text: Vec<String>) -> u32 { 
    let mut modules:   Vec<Module> = vec![];
    for line in wall_of_text{
        let res = line.split(" -> ").collect::<Vec<&str>>();
        println!("{:?}", res);
        if res[0].get(0..1).unwrap() == "%" {
            println!("%");
            modules.push(Module { kind: ModuleType::FlipFlop, states: [true].to_vec(), outputs: vec![] });
        }
        else if res[0].get(0..1).unwrap() == "&" {
            let temp_module = Module { kind: ModuleType::Conjunction, states: vec![], outputs: vec![] };
            println!("{:?}", temp_module.states);
            modules.push(temp_module);
            println!("&");
        }
    }
    return 0;
}

fn main() -> io::Result<()>  {
    let file = File::open("../test.txt")?;
    // let file = File::open("../input.txt")?;
    let reader = BufReader::new(file);
    let answer: u32 = process_text(
        reader.lines().collect::<io::Result<Vec<String>>>().expect("failed")
    );
    println!("{}", answer);

    Ok(())
}
