use std::fs::File;
use std::io::{self, prelude::*, BufReader};
use regex::Regex;

fn find_numbers(line: &str) -> Vec<(i32, i32)> {
    let re = Regex::new(r"\d+").unwrap();
    let matches: Vec<_> = re.find_iter(line).map(|m| m.range()).collect();
    let mut return_vec: Vec<(i32, i32)> = vec![];
    for i in matches {
        return_vec.push((i.start as i32, i.end as i32));
        // println!("first {}, Last {}", i.start, i.end); 
        // println!("number {}", line.get(i.start..i.end).unwrap().parse::<u32>().unwrap()); 
    }
    return return_vec;
}

fn find_symbol(line: &str) -> Vec<u32> {
    let re = Regex::new(r"[^A-Za-z0-9.]").unwrap();
    let matches: Vec<_> = re.find_iter(line).map(|m| m.range()).collect();
    let mut return_vec: Vec<u32> = vec![];
    for i in matches {
        return_vec.push((i.start as i32).try_into().unwrap());
        println!("first {}, Last {}", i.start, i.end); 
        println!("symbol {}", line.get(i.start..i.end).unwrap()); 
    }
    return return_vec;
}

fn clip(val: i32, min:i32, max: i32) -> usize {
    if val < min 
    {
        return min.try_into().unwrap();
    }
    if val > max 
    {
        return max.try_into().unwrap();
    }
    return val.try_into().unwrap();
}

fn does_window_contain_symbol(coordinates: (usize, usize, usize, usize), text: &Vec<String>) -> bool
{
    let re = Regex::new(r"[^A-Za-z0-9.]").unwrap();
    let mut window_string = String::new();
    let window = &text[coordinates.0..(coordinates.2+1)];
    for i in window 
    {
        let var = i.get(coordinates.1..(coordinates.3)).unwrap();
        window_string.push_str(var);
        // println!("{}", i);
    }
    println!("{}", window_string);
    return re.is_match(&window_string);
}


fn process_text(wall_of_text: Vec<String>) -> u32 {
    let mut sum: u32 = 0;

    for (line_count, line) in wall_of_text.clone().into_iter().enumerate() {
        let x = find_numbers(&line);
        // let y = find_symbol(&line);
        for i in x {
            let coor = (
                clip(i32::try_from(line_count).unwrap()-1, 0, i32::try_from(wall_of_text.len()).unwrap()-1),
                clip(i.0-1i32, 0, i32::try_from(line.len()).unwrap()-1), 
                clip(i32::try_from(line_count).unwrap()+1, 0, i32::try_from(wall_of_text.len()).unwrap()-1),
                clip(i.1+1, 0, i32::try_from(line.len()).unwrap()-1),
                );
            let engine_part = does_window_contain_symbol(coor, &wall_of_text);
            if engine_part 
            {
                sum += line.get(i.0.try_into().unwrap()..i.1.try_into().unwrap()).unwrap().parse::<u32>().unwrap();
            }
        }
    }
    // let _throw_way = does_window_contain_symbol((2,2,4,4), wall_of_text);
    return sum;
}

fn main() -> io::Result<()>  {
    // let file = File::open("../test.txt")?;
    let file = File::open("../input.txt")?;
    let reader = BufReader::new(file);
    let answer: u32 = process_text(
        reader.lines().collect::<io::Result<Vec<String>>>().expect("failed")
    );
    println!("{}", answer);

    Ok(())
}
