use std::fs::File;
use std::io::{self, prelude::*, BufReader};
use regex::Regex;

fn find_numbers(line: &str) -> Vec<u32> {
    let re = Regex::new(r"\d+").unwrap();
    let matches: Vec<_> = re.find_iter(line).map(|m| m.as_str().parse::<u32>().unwrap()).collect();
    let mut return_vec: Vec<u32> = vec![];
    for i in matches {
        return_vec.push(i);
    }
    return return_vec;
}

fn process_line(line: String) -> u32 {
    let parts = line.split(&[':']).collect::<Vec<&str>>();
    let sets = parts[1].split("|").collect::<Vec<&str>>();
    let winning_numbers = find_numbers(&sets[0]);
    let mut card_sum = 0;
    let my_numbers = find_numbers(&sets[1]);
    for num in &my_numbers
    {
       for winning_num in &winning_numbers 
       {
           if num == winning_num { card_sum +=1; }
       }
    }
    if card_sum > 0 {return 2u32.pow(card_sum-1); }
    else { return 0; }
}

fn main() -> io::Result<()>  {
    let mut sum: u32 = 0;
    let file = File::open("../input.txt")?;
    let reader = BufReader::new(file);
    for line in reader.lines() {
        sum = process_line(line?) + sum;
    }
    println!("{}", sum);

    Ok(())
}
